using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Net;

using System.IO;

namespace GMDL
{
    public partial class TileLevelPullMerge : Form
    {
        public TileLevelPullMerge(WebClient WC)
        {
            InitializeComponent();

            wc = WC;
        }

        WebClient wc;

        private void Cx_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            CUSTOMurl.SelectedText = "$x$";
        }

        private void Cy_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            CUSTOMurl.SelectedText = "$y$";
        }

        private void Cz_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            CUSTOMurl.SelectedText = "$z$";
        }

        private void PullLevel_Click(object sender, EventArgs e)
        {
            Prog.Text = "Working . . .";
            Application.DoEvents();

            DirectoryInfo dir = new DirectoryInfo(Dir.Text);
            if (dir.Exists == false)
                dir.Create();

            LayoutCSV_LinkClicked_Proc(false);

            int z = Int32.Parse(Mzoom.Text);
            int x = Int32.Parse(Mx.Text);
            int y = Int32.Parse(My.Text);

            int xI = Int32.Parse(MxI.Text);
            int yI = Int32.Parse(MyI.Text);

            int xS = Int32.Parse(MxS.Text);
            int yS = Int32.Parse(MyS.Text);

            int count = 1;
            int total = xS * yS;

            int errors = 0;
            int true_done = 0;

            int xTS = xS;
            int i = 0;
            while (xTS > 0)
            {
                int yTS = yS;
                int j = 0;

                while (yTS > 0)
                {
                    int xT = x + i * xI;
                    int yT = y + j * yI;

                    string file = i.ToString() + "_" + j.ToString() + ext.Text;

                    string url = CUSTOMurl.Text;
                    url = url.Replace("$x$", xT.ToString(MxF.Text));
                    url = url.Replace("$y$", yT.ToString(MyF.Text));
                    url = url.Replace("$z$", z.ToString(MzF.Text));

                    Prog.Text = "On " + count.ToString() + " of " + total.ToString() + " (" + true_done.ToString() + " done, " + errors.ToString() + " errors)";
                    Application.DoEvents();
                    count++;

                    if (new FileInfo(Dir.Text + "\\" + file).Exists == false)
                    {
                        try
                        {
                            wc.DownloadFile(url, Dir.Text + "\\" + file);

                            Bitmap testbm = new Bitmap(new MemoryStream(File.ReadAllBytes(Dir.Text + "\\" + file)));
                            testbm.Dispose();

                            true_done++;
                        }
                        catch
                        {
                            errors++;
                            StreamWriter sw = new StreamWriter(Dir.Text + "\\" + file, false); // need the len 0 files for the merge
                            sw.Close();
                        }
                    }

                    yTS--;
                    j++;
                }

                xTS--;
                i++;
            }

            MessageBox.Show("Done: " + total.ToString() + " (" + true_done.ToString() + " done, " + errors.ToString() + " errors)" + "\n\n(you may wish to rerun to fill in the blanks, and delete 0 sized tiles prior to that)");
            Prog.Text = "Done";
            Application.DoEvents();
        }

        private void MergeLevel_Click(object sender, EventArgs e)
        {
            DirectoryInfo dir = new DirectoryInfo(Dir.Text + "_MERGED");
            if (dir.Exists)
            {
                MessageBox.Show("Already there");
            }
            else
            {
                Prog.Text = "Working . . .";
                Application.DoEvents();

                dir.Create();

                string file_to_check = "";

                foreach (FileInfo fi in new DirectoryInfo(Dir.Text).GetFiles())
                {
                    if (file_to_check == "" && fi.Name.StartsWith(".") == false && fi.Name.IndexOf("_") != -1 && fi.Length > 0)
                    {
                        file_to_check = fi.Name;
                    }
                }

                Bitmap for_size = new Bitmap(Dir.Text + "\\" + file_to_check);
                int h = for_size.Height;
                int w = for_size.Width;
                for_size.Dispose();

                int xH = 10000 / w;
                int yH = 10000 / h;

                int in_segment = 0;

                int xB = 0;
                int x = 0;
                int y = 0;
                bool more_x = true;
                while (more_x)
                {
                    int yB = 0;

                    y = 0;
                    bool more_y = true;

                    while (more_y)
                    {
                        int i_max = 0;
                        int j_max = 0;

                        int i = 0;

                        in_segment = 0;

                        while (i < xH)
                        {
                            int j = 0;
                            while (j < yH)
                            {
                                string file = Dir.Text + "\\" + (x + i).ToString() + "_" + (y + j).ToString() + ext.Text;

                                FileInfo fileF = new FileInfo(file);

                                if (fileF.Exists)
                                {
                                    in_segment++;

                                    if (i > i_max)
                                        i_max = i;
                                    if (j > j_max)
                                        j_max = j;
                                }

                                j++;
                            }
                            i++;
                        }

                        if (in_segment > 0)
                        {
                            Bitmap tileBIG = new Bitmap((i_max + 1) * w, (j_max + 1) * h);
                            i = 0;
                            while (i < xH)
                            {
                                int j = 0;
                                while (j < yH)
                                {
                                    string file = Dir.Text + "\\" + (x + i).ToString() + "_" + (y + j).ToString() + ext.Text;

                                    FileInfo fileF = new FileInfo(file);

                                    if (fileF.Exists)
                                    {
                                        if (fileF.Length > 0)
                                        {
                                            Bitmap src = new Bitmap(file);

                                            Rectangle srcRect = new Rectangle();
                                            Rectangle destRect = new Rectangle();

                                            using (Graphics g = Graphics.FromImage(tileBIG))
                                            {
                                                Brush b = new SolidBrush(Color.Transparent);
                                                g.FillRectangle(b, destRect);
                                                srcRect.Width = w;
                                                srcRect.Height = h;

                                                destRect.Width = w;
                                                destRect.Height = h;
                                                destRect.X = i * w;
                                                destRect.Y = j * h;

                                                g.DrawImage(src, destRect, srcRect, System.Drawing.GraphicsUnit.Pixel);
                                            }
                                            src.Dispose();
                                        }
                                    }

                                    j++;
                                }
                                i++;
                            }

                            tileBIG.Save(Dir.Text + "_MERGED" + "\\" + xB.ToString() + "_" + yB.ToString() + ".png", System.Drawing.Imaging.ImageFormat.Png);
                            tileBIG.Dispose();
                        }

                        yB++;
                        y += yH;

                        if (in_segment == 0)
                            more_y = false;
                    }
                    xB++;
                    x += xH;

                    if (in_segment == 0)
                    {
                        if (more_y == false && y == yH)
                        {
                            more_x = false;
                        }
                    }
                }
                Prog.Text = "Done";
                Application.DoEvents();
                MessageBox.Show("Done: " + Dir.Text + "_MERGED");
            }

        }

        private void SetDir_Click(object sender, EventArgs e)
        {
            string dir = System.IO.Directory.GetCurrentDirectory();

            FolderBrowserDialog file = new FolderBrowserDialog();
            file.ShowDialog();

            System.IO.Directory.SetCurrentDirectory(dir);

            if (file.SelectedPath != "")
            {
                Dir.Text = file.SelectedPath;
                AddDir_Click(Type.Missing, EventArgs.Empty);
            }
        }

        private void AddDir_Click(object sender, EventArgs e)
        {
            if (Dir.Text != "")
            {
                if (new DirectoryInfo(Dir.Text).Exists)
                {
                    if (new FileInfo(Dir.Text + "\\" + "dir.settings").Exists)
                    {
                        StreamReader sr = new StreamReader(Dir.Text + "\\dir.settings");
                        while (sr.EndOfStream == false)
                        {
                            string line = sr.ReadLine();
                            if (line.StartsWith("#"))
                            {
                                string ct = line.Substring(1, line.IndexOf("#", 1) - 1);
                                string val = line.Substring(line.LastIndexOf("#") + 1, line.Length - 1 - line.LastIndexOf("#"));
                                foreach (Control cont in this.Controls)
                                {
                                    if (cont.Name == ct)
                                        ((TextBox)cont).Text = val;
                                }
                            }
                        }
                        sr.Close();

                        MessageBox.Show("Loaded settings");
                    }
                }
            }
        }

        private void LayoutCSV_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            LayoutCSV_LinkClicked_Proc(true);
        }

        private void LayoutCSV_LinkClicked_Proc(bool do_msg)
        {
            DirectoryInfo dir = new DirectoryInfo(Dir.Text);
            if (dir.Exists == false)
                dir.Create();

            StreamWriter sw = new StreamWriter(Dir.Text + "\\dir.settings", false);

            sw.WriteLine("#ext#" + ext.Text);
            sw.WriteLine("#CUSTOMurl#" + CUSTOMurl.Text);

            sw.WriteLine("#Mzoom#" + Mzoom.Text);
            sw.WriteLine("#Mx#" + Mx.Text);
            sw.WriteLine("#My#" + My.Text);

            sw.WriteLine("#MzF#" + MzF.Text);
            sw.WriteLine("#MxF#" + MxF.Text);
            sw.WriteLine("#MyF#" + MyF.Text);

            sw.WriteLine("#MxI#" + MxI.Text);
            sw.WriteLine("#MyI#" + MyI.Text);

            sw.WriteLine("#MxS#" + MxS.Text);
            sw.WriteLine("#MyS#" + MyS.Text);
            
            sw.Close();

            if (do_msg)
            {
                MessageBox.Show("Done: " + Dir.Text + "\\dir.settings");
            }
        }

        private void MoveUp_Click(object sender, EventArgs e)
        {
            if (Dir.Text != "")
            {
                DirectoryInfo d_in = new DirectoryInfo(Dir.Text);
                DirectoryInfo d_out = new DirectoryInfo(Dir.Text + "_SHIFTED");
                if (d_in.Exists && d_out.Exists == false)
                {
                    Prog.Text = "Working . . .";
                    Application.DoEvents();

                    d_out.Create();
                    int x_shift = Int32.Parse(MUx.Text);
                    int y_shift = Int32.Parse(MUy.Text);

                    foreach (FileInfo f_in in d_in.GetFiles())
                    {
                        if (f_in.Name == "dir.settings")
                        {
                            StreamReader sr = new StreamReader(Dir.Text + "\\dir.settings");
                            StreamWriter sw = new StreamWriter(Dir.Text + "_SHIFTED" + "\\dir.settings");
                            while (sr.EndOfStream == false)
                            {
                                string line = sr.ReadLine();
                                if (line.StartsWith("#Mx#") || line.StartsWith("#MxS#") || line.StartsWith("#My#") || line.StartsWith("#MyS#"))
                                {
                                    string ct = line.Substring(1, line.IndexOf("#", 1) - 1);
                                    string val = line.Substring(line.LastIndexOf("#") + 1, line.Length - 1 - line.LastIndexOf("#"));
                                    if (line.StartsWith("#Mx#"))
                                        sw.WriteLine("#" + ct + "#" + (Int32.Parse(val) - Int32.Parse(MxI.Text) * x_shift).ToString());
                                    if (line.StartsWith("#MxS#"))
                                        sw.WriteLine("#" + ct + "#" + (Int32.Parse(val) + x_shift).ToString());
                                    if (line.StartsWith("#My#"))
                                        sw.WriteLine("#" + ct + "#" + (Int32.Parse(val) - Int32.Parse(MyI.Text) * y_shift).ToString());
                                    if (line.StartsWith("#MyS#"))
                                        sw.WriteLine("#" + ct + "#" + (Int32.Parse(val) + y_shift).ToString());
                                }
                                else
                                {
                                    sw.WriteLine(line);
                                }
                            }
                            sr.Close();
                            sw.Close();
                        }
                        else
                        {
                            int x = Int32.Parse(f_in.Name.Substring(0, f_in.Name.IndexOf("_")));
                            int y = Int32.Parse(f_in.Name.Substring(f_in.Name.IndexOf("_") + 1, (f_in.Name + ".").IndexOf(".") - 1 - f_in.Name.IndexOf("_")));

                            string f_out = (x + x_shift).ToString() + "_" + (y + y_shift).ToString();
                            if (f_in.Name.IndexOf(".") != -1)
                            {
                                f_out = f_out + f_in.Name.Substring(f_in.Name.IndexOf("."), f_in.Name.Length - f_in.Name.IndexOf("."));
                            }

                            f_in.CopyTo(Dir.Text + "_SHIFTED" + "\\" + f_out);
                        }
                    }
                    Prog.Text = "Done";
                    Application.DoEvents();
                    MessageBox.Show("Done: " + Dir.Text + "_SHIFTED");
                }
            }
        }

    }
}